{$M 2048,0,0}

uses Clavier,Convert,EcranTxt,FaitPaus;

const
  NomJour : array[0..6] of string[8] = (
    'Dimanche','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi');

  NomMois : array[1..12] of string[9] = (
    'Janvier','Fvrier','Mars','Avril','Mai','Juin','Juillet','Aout','Septembre',
    'Octobre','Novembre','Dcembre');

var
  Js,J,M,
  H,S: byte;
  A: word;
  txt: string;

{ Lit la valeur 8 bits de la fonction spcifie du CMOS en la convertisant }
{ au format dcimal }
function LitCmosBcd8 (fonction: byte) : byte; begin
  Port[$70] := fonction;
  LitCmosBcd8 := Bcd2Dec8(Port[$71]);
end;

procedure LitDateCmos (var JourSemaine,jour,mois: byte; var annee: word); begin
  { Lit le jour de la semaine }
  asm
    mov ah,2Ah
    int 21h
    les di,[JourSemaine]
    mov es:[di],al { devrait tre gal  LitCmos(6), mais ce dernier dconne }
  end;

  jour  := LitCmosBcd8($07);      { Jour du mois }
  mois  := LitCmosBcd8($08);      { Mois }
  annee := LitCmosBcd8($32)*100 +LitCmosBcd8($09); { Anne = }
                                  { Siecle*100 +Anne (entre 0 et 99) }
end;

procedure LitHeureCmos (var heure,minute,seconde: byte); begin
  heure   := LitCmosBcd8($04);    { Heure   de l'horloge CMOS }
  minute  := LitCmosBcd8($02);    { Minute  de l'horloge CMOS }
  seconde := LitCmosBcd8($00);    { Seconde de l'horloge CMOS }
end;

begin
  EffaceEcranTxt; CurseurOff;

  EcriTxc (-1,3,'- Enfoncez une touche pour quitter -',11); PosXY (0,0);

  { Ecrit la date }
  LitDateCmos (Js,J,M,A);
  Ecrit ('Nous sommes ');
  Ecritc (NomJour[Js],14); Ecrit (', le ');
  CoulTxt := 14;
  Str (J,txt); Ecrit (txt+' '+NomMois[M]+' ');
  Str (A,txt); Ecrit (txt+'  ');

  { Ecrit le tout en abrg (J/M/A) }
  CoulTxt := 15+3*16;
  Str (J,txt); Ecrit ('('+txt+'/');
  Str (M,txt); Ecrit (txt+'/');
  Str (A,txt); EcriTr (txt+')');
  CoulTxt := 7;

  { Ecrit l'heure avec actualisation toutes les secondes }
  Ecrit ('Il est exactement : '); SauvePosCurTxt;
  repeat
    LitHeureCmos (H,M,S);
    RemetPosCurTxt;
    Str (H,txt); EcriTc (txt,14); Ecrit ('h ');
    Str (M,txt); EcriTc (txt,14); Ecrit ('min ');
    Str (S,txt); EcriTc (txt,14); Ecrit ('s   '); { Les espaces sont l pour }
                                                  { effacer l'ancienne heure }

    { Attend une seconde en vrifiant toutes les 0.1s si une touche n'a pas }
    { t presse }
    S := 0;
    repeat
      pause (100);
      inc (S);
    until TouchPresse or (S=10);
  until TouchPresse;

  EcriTxh (0,3,80,' ');
  PosXY (0,2);
  CurseurOn;
end.